
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;


entity CLK_X is
port
(
	din      	: in  std_logic_vector(63 downto 0)    := (others => '0');
	clkin		: in std_logic := '0';
	
	dout      	: out  std_logic_vector(63 downto 0)    := (others => '0');
	clkout		: in std_logic := '0'
);

end entity CLK_X;

architecture rtl of CLK_X is

signal	din_fifo	: std_logic_vector(63 downto 0)	:= (others => '0');
signal	dout_fifo	: std_logic_vector(63 downto 0)	:= (others => '0');

signal	din1	: std_logic_vector(63 downto 0)	:= (others => '0');
signal	din2	: std_logic_vector(63 downto 0)	:= (others => '0');
signal	dout1	: std_logic_vector(63 downto 0)	:= (others => '0');
signal	dout2	: std_logic_vector(63 downto 0)	:= (others => '0');
	  
  component DC_FIFO_64 is
  PORT(
		data		: IN STD_LOGIC_VECTOR (63 DOWNTO 0);
		rdclk		: IN STD_LOGIC ;
		rdreq		: IN STD_LOGIC ;
		wrclk		: IN STD_LOGIC ;
		wrreq		: IN STD_LOGIC ;
		q			: OUT STD_LOGIC_VECTOR (63 DOWNTO 0)
		);
  end component;
                                                           
                                                           
begin                                                                                                                                     
                                                           


--xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
-- Instance components here
--xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
i0: DC_FIFO_64
    port map
    (   
		data		=> din_fifo,	
		rdclk		=> clkout  ,
		rdreq		=> '1'     ,
		wrclk		=> clkin   ,
		wrreq		=> '1'     ,
		q			=> dout_fifo	
	);         	

	
process(clkin)
begin
	if rising_edge(clkin) then -- just a little pipeline to aid timing.
		din1 <= din;
		din2 <= din1;
		din_fifo <= din2;
	end if;
end process;	

process(clkout)
begin
	if rising_edge(clkout) then
		dout1 <= dout_fifo;	
		dout2 <= dout1;		
		dout <= dout2;


	end if;
end process;	
	
end rtl;
